#ifndef ABCP_H
#define ABCP_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#ifdef DLL
#include <windows.h>
#endif


#ifndef USHORT
#define USHORT unsigned short int
#endif

#ifndef ULONG
#define ULONG unsigned long int
#endif


/*
** This is the re2c interface
*/

#define YYCTYPE   unsigned char
#define YYCURSOR  cursor
#define YYLIMIT   limit
#define YYMARKER  marker
#define YYFILL(n)


#define S_EOF        0x0000
#define S_ERROR      0x0001
#define S_LIMBO      0x0002
#define S_NONE       0x0003
#define S_TUNE       0x0100
#define S_FIELD      0x1000  
#define S_EXTFIELD   0x2000
#define S_INFIELD    0x4000
#define S_ANYFIELD   0x7000


#define m_LFIELD(x)  ((x)->state & 0x00FF)
#define m_isFIELD(x) ((x)->state & S_FIELD)

#define States USHORT

typedef enum {
  T_FIRST,
  T_UNKNOWN,   T_NONE,      T_EOF,       T_COMMENT,   T_EMPTYLINE,
  T_EXTFIELD,  T_FIELD,     T_NOTE,      T_WSPACE,    T_BAR,
  T_INFIELD,   T_TEXT,      T_ENDLINE,   T_CONTINUE,  T_DECOR,
  T_REST,      T_INVREST,   T_MULTIREST, T_SPACER,    T_NPLET,
  T_OPENSLUR,  T_CLOSESLUR, T_DOTRIGHT,  T_DOTLEFT,   T_CHORDSTART,
  T_CHORDEND,  T_CHORD,     T_REPEAT,    T_GRACEAPP,  T_GRACEACC,
  T_GRACEEND,  T_TIE,       T_STRING,    T_STRINGUNF, T_ANNOTATION,
  T_BREAK,     T_OVERLAY,   T_STARTLINE, T_FIELDB,    T_PRAGMA,
  T_LYR_SYLL,  T_LYR_BLANK, T_LYR_BAR,   T_LYR_SPACE, T_LYR_CONT,
  T_LYR_VERSE,
  T_LAST
} Tokens;


typedef struct {
  USHORT   guard;
  USHORT   token;
  USHORT   state;
  USHORT   line;
  USHORT   toklen;
  USHORT   nextstate;
  ULONG    bufsize;
  FILE    *file;
  YYCTYPE *cursor;
  YYCTYPE *limit;
  YYCTYPE *marker;
  YYCTYPE *buffer;
  YYCTYPE *tokstr;
  YYCTYPE *filename;
  YYCTYPE *bufaux;
} abcScanner;

#define abcHandle void * 

typedef int (*abcHandler)(abcHandle h);


int abcScanFile(char *filename,abcHandler handler);
int abcScanString(char *buffer,abcHandler handler);

Tokens      abcToken(abcScanner *s);
const char *abcTokenName(Tokens n);
States      abcState(abcScanner *s);
const char *abcStateName(States s);
const char *abcString(abcScanner *s);
const char *abcFilename(abcScanner *s);
int         abcLine(abcScanner *s);
int         abcColumn(abcScanner *s);

#endif